"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
let lastTaskId = 0;
const callbacks = new Map();
exports.loadWorker = (url, options) => {
    const worker = new Worker(url, options);
    worker.onmessage = (event) => {
        const [errored, taskId, result] = event.data;
        const [resolve, reject] = callbacks.get(taskId);
        if (!errored)
            resolve(result);
        else
            reject(result);
        callbacks.delete(taskId);
    };
    const dispatch = (data, transferList) => {
        const taskId = lastTaskId++;
        const promise = new Promise((resolve, reject) => {
            callbacks.set(taskId, [resolve, reject]);
        });
        worker.postMessage([taskId, data], transferList);
        return promise;
    };
    return dispatch;
};
